maint.mk: add sc_vulnerable_makefile_CVE-2012-3386
[gnulib.git] / top / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2012 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Diagnostic for continued use of deprecated variable.
25 # Remove in 2013
26 ifneq ($(build_aux),)
27  $(error "$(ME): \
28 set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29 endif
30
31 # Do not save the original name or timestamp in the .tar.gz file.
32 # Use --rsyncable if available.
33 gzip_rsyncable := \
34   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
35     && printf %s --rsyncable)
36 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
37
38 GIT = git
39 VC = $(GIT)
40
41 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
42
43 # You can override this variable in cfg.mk to set your own regexp
44 # matching files to ignore.
45 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
46
47 # This is to preprocess robustly the output of $(VC_LIST), so that even
48 # when $(srcdir) is a pathological name like "....", the leading sed command
49 # removes only the intended prefix.
50 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
51
52 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53 # when $(srcdir) is not ".".
54 ifeq ($(srcdir),.)
55 _prepend_srcdir_prefix =
56 else
57 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
58 endif
59
60 # In order to be able to consistently filter "."-relative names,
61 # (i.e., with no $(srcdir) prefix), this definition is careful to
62 # remove any $(srcdir) prefix, and to restore what it removes.
63 _sc_excl = \
64   $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
65 VC_LIST_EXCEPT = \
66   $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
67         | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
68           else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
69         | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
70         $(_prepend_srcdir_prefix)
71
72 ifeq ($(origin prev_version_file), undefined)
73   prev_version_file = $(srcdir)/.prev-version
74 endif
75
76 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
77 VERSION_REGEXP = $(subst .,\.,$(VERSION))
78 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
79
80 ifeq ($(VC),$(GIT))
81 this-vc-tag = v$(VERSION)
82 this-vc-tag-regexp = v$(VERSION_REGEXP)
83 else
84 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
85 tag-this-version = $(subst .,_,$(VERSION))
86 this-vc-tag = $(tag-package)-$(tag-this-version)
87 this-vc-tag-regexp = $(this-vc-tag)
88 endif
89 my_distdir = $(PACKAGE)-$(VERSION)
90
91 # Old releases are stored here.
92 release_archive_dir ?= ../release
93
94 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95 # Use alpha.gnu.org for alpha and beta releases.
96 # Use ftp.gnu.org for stable releases.
97 gnu_ftp_host-alpha = alpha.gnu.org
98 gnu_ftp_host-beta = alpha.gnu.org
99 gnu_ftp_host-stable = ftp.gnu.org
100 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
101
102 ifeq ($(gnu_rel_host),ftp.gnu.org)
103 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
104 else
105 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
106 endif
107
108 # Override this in cfg.mk if you are using a different format in your
109 # NEWS file.
110 today = $(shell date +%Y-%m-%d)
111
112 # Select which lines of NEWS are searched for $(news-check-regexp).
113 # This is a sed line number spec.  The default says that we search
114 # lines 1..10 of NEWS for $(news-check-regexp).
115 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116 news-check-lines-spec ?= 1,10
117 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
118
119 # Prevent programs like 'sort' from considering distinct strings to be equal.
120 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
121 export LC_ALL = C
122
123 ## --------------- ##
124 ## Sanity checks.  ##
125 ## --------------- ##
126
127 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
128
129 # Collect the names of rules starting with 'sc_'.
130 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131                         $(srcdir)/$(ME) $(_cfg_mk)))
132 .PHONY: $(syntax-check-rules)
133
134 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
135 local-checks-available += $(syntax-check-rules)
136 else
137 local-checks-available += no-vc-detected
138 no-vc-detected:
139         @echo "No version control files detected; skipping syntax check"
140 endif
141 .PHONY: $(local-checks-available)
142
143 # Arrange to print the name of each syntax-checking rule just before running it.
144 $(syntax-check-rules): %: %.m
145 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
146 .PHONY: $(sc_m_rules_)
147 $(sc_m_rules_):
148         @echo $(patsubst sc_%.m, %, $@)
149         @date +%s.%N > .sc-start-$(basename $@)
150
151 # Compute and print the elapsed time for each syntax-check rule.
152 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
153 .PHONY: $(sc_z_rules_)
154 $(sc_z_rules_): %.z: %
155         @end=$$(date +%s.%N);                                           \
156         start=$$(cat .sc-start-$*);                                     \
157         rm -f .sc-start-$*;                                             \
158         awk -v s=$$start -v e=$$end                                     \
159           'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
160
161 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
162 # that computes and prints elapsed time.
163 local-check :=                                                          \
164   $(patsubst sc_%, sc_%.z,                                              \
165     $(filter-out $(local-checks-to-skip), $(local-checks-available)))
166
167 syntax-check: $(local-check)
168
169 # _sc_search_regexp
170 #
171 # This macro searches for a given construct in the selected files and
172 # then takes some action.
173 #
174 # Parameters (shell variables):
175 #
176 #  prohibit | require
177 #
178 #     Regular expression (ERE) denoting either a forbidden construct
179 #     or a required construct.  Those arguments are exclusive.
180 #
181 #  exclude
182 #
183 #     Regular expression (ERE) denoting lines to ignore that matched
184 #     a prohibit construct.  For example, this can be used to exclude
185 #     comments that mention why the nearby code uses an alternative
186 #     construct instead of the simpler prohibited construct.
187 #
188 #  in_vc_files | in_files
189 #
190 #     grep-E-style regexp selecting the files to check.  For in_vc_files,
191 #     the regexp is used to select matching files from the list of all
192 #     version-controlled files; for in_files, it's from the names printed
193 #     by "find $(srcdir)".  When neither is specified, use all files that
194 #     are under version control.
195 #
196 #  containing | non_containing
197 #
198 #     Select the files (non) containing strings matching this regexp.
199 #     If both arguments are specified then CONTAINING takes
200 #     precedence.
201 #
202 #  with_grep_options
203 #
204 #     Extra options for grep.
205 #
206 #  ignore_case
207 #
208 #     Ignore case.
209 #
210 #  halt
211 #
212 #     Message to display before to halting execution.
213 #
214 # Finally, you may exempt files based on an ERE matching file names.
215 # For example, to exempt from the sc_space_tab check all files with the
216 # .diff suffix, set this Make variable:
217 #
218 # exclude_file_name_regexp--sc_space_tab = \.diff$
219 #
220 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
221 # when filtering by name via in_files, we explicitly filter out matching
222 # names here as well.
223
224 # Initialize each, so that envvar settings cannot interfere.
225 export require =
226 export prohibit =
227 export exclude =
228 export in_vc_files =
229 export in_files =
230 export containing =
231 export non_containing =
232 export halt =
233 export with_grep_options =
234
235 # By default, _sc_search_regexp does not ignore case.
236 export ignore_case =
237 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
238
239 define _sc_say_and_exit
240    dummy=; : so we do not need a semicolon before each use;             \
241    { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
242 endef
243
244 define _sc_search_regexp
245    dummy=; : so we do not need a semicolon before each use;             \
246                                                                         \
247    : Check arguments;                                                   \
248    test -n "$$prohibit" && test -n "$$require"                          \
249      && { msg='Cannot specify both prohibit and require'                \
250           $(_sc_say_and_exit) } || :;                                   \
251    test -z "$$prohibit" && test -z "$$require"                          \
252      && { msg='Should specify either prohibit or require'               \
253           $(_sc_say_and_exit) } || :;                                   \
254    test -z "$$prohibit" && test -n "$$exclude"                          \
255      && { msg='Use of exclude requires a prohibit pattern'              \
256           $(_sc_say_and_exit) } || :;                                   \
257    test -n "$$in_vc_files" && test -n "$$in_files"                      \
258      && { msg='Cannot specify both in_vc_files and in_files'            \
259           $(_sc_say_and_exit) } || :;                                   \
260    test "x$$halt" != x                                                  \
261      || { msg='halt not defined' $(_sc_say_and_exit) };                 \
262                                                                         \
263    : Filter by file name;                                               \
264    if test -n "$$in_files"; then                                        \
265      files=$$(find $(srcdir) | grep -E "$$in_files"                     \
266               | grep -Ev '$(_sc_excl)');                                \
267    else                                                                 \
268      files=$$($(VC_LIST_EXCEPT));                                       \
269      if test -n "$$in_vc_files"; then                                   \
270        files=$$(echo "$$files" | grep -E "$$in_vc_files");              \
271      fi;                                                                \
272    fi;                                                                  \
273                                                                         \
274    : Filter by content;                                                 \
275    test -n "$$files" && test -n "$$containing"                          \
276      && { files=$$(grep -l "$$containing" $$files); } || :;             \
277    test -n "$$files" && test -n "$$non_containing"                      \
278      && { files=$$(grep -vl "$$non_containing" $$files); } || :;        \
279                                                                         \
280    : Check for the construct;                                           \
281    if test -n "$$files"; then                                           \
282      if test -n "$$prohibit"; then                                      \
283        grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
284          | grep -vE "$${exclude:-^$$}"                                  \
285          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
286      else                                                               \
287        grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
288            | grep .                                                     \
289          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
290      fi                                                                 \
291    else :;                                                              \
292    fi || :;
293 endef
294
295 sc_avoid_if_before_free:
296         @$(srcdir)/$(_build-aux)/useless-if-before-free                 \
297                 $(useless_free_options)                                 \
298             $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) &&   \
299           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
300             exit 1; } || :
301
302 sc_cast_of_argument_to_free:
303         @prohibit='\<free *\( *\(' halt="don't cast free argument"      \
304           $(_sc_search_regexp)
305
306 sc_cast_of_x_alloc_return_value:
307         @prohibit='\*\) *x(m|c|re)alloc\>'                              \
308         halt="don't cast x*alloc return value"                          \
309           $(_sc_search_regexp)
310
311 sc_cast_of_alloca_return_value:
312         @prohibit='\*\) *alloca\>'                                      \
313         halt="don't cast alloca return value"                           \
314           $(_sc_search_regexp)
315
316 sc_space_tab:
317         @prohibit='[ ]  '                                               \
318         halt='found SPACE-TAB sequence; remove the SPACE'               \
319           $(_sc_search_regexp)
320
321 # Don't use *scanf or the old ato* functions in "real" code.
322 # They provide no error checking mechanism.
323 # Instead, use strto* functions.
324 sc_prohibit_atoi_atof:
325         @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\('                           \
326         halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q'   \
327           $(_sc_search_regexp)
328
329 # Use STREQ rather than comparing strcmp == 0, or != 0.
330 sp_ = strcmp *\(.+\)
331 sc_prohibit_strcmp:
332         @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)'         \
333         exclude=':# *define STRN?EQ\('                                  \
334         halt='$(ME): replace strcmp calls above with STREQ/STRNEQ'      \
335           $(_sc_search_regexp)
336
337 # Really.  You don't want to use this function.
338 # It may fail to NUL-terminate the destination,
339 # and always NUL-pads out to the specified length.
340 sc_prohibit_strncpy:
341         @prohibit='\<strncpy *\('                                       \
342         halt='do not use strncpy, period'                               \
343           $(_sc_search_regexp)
344
345 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
346 # Convert all uses automatically, via these two commands:
347 # git grep -l '\<exit *(1)' \
348 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
349 #  | xargs --no-run-if-empty \
350 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
351 # git grep -l '\<exit *(0)' \
352 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
353 #  | xargs --no-run-if-empty \
354 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
355 sc_prohibit_magic_number_exit:
356         @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,'     \
357         halt='use EXIT_* values rather than magic number'                       \
358           $(_sc_search_regexp)
359
360 # Using EXIT_SUCCESS as the first argument to error is misleading,
361 # since when that parameter is 0, error does not exit.  Use '0' instead.
362 sc_error_exit_success:
363         @prohibit='error *\(EXIT_SUCCESS,'                              \
364         in_vc_files='\.[chly]$$'                                        \
365         halt='found error (EXIT_SUCCESS'                                \
366          $(_sc_search_regexp)
367
368 # "FATAL:" should be fully upper-cased in error messages
369 # "WARNING:" should be fully upper-cased, or fully lower-cased
370 sc_error_message_warn_fatal:
371         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
372             | grep -E '"Warning|"Fatal|"fatal' &&                       \
373           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
374             exit 1; } || :
375
376 # Error messages should not start with a capital letter
377 sc_error_message_uppercase:
378         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
379             | grep -E '"[A-Z]'                                          \
380             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
381           { echo '$(ME): found capitalized error message' 1>&2;         \
382             exit 1; } || :
383
384 # Error messages should not end with a period
385 sc_error_message_period:
386         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
387             | grep -E '[^."]\."' &&                                     \
388           { echo '$(ME): found error message ending in period' 1>&2;    \
389             exit 1; } || :
390
391 sc_file_system:
392         @prohibit=file''system                                          \
393         ignore_case=1                                                   \
394         halt='found use of "file''system"; spell it "file system"'      \
395           $(_sc_search_regexp)
396
397 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
398 sc_prohibit_have_config_h:
399         @prohibit='^# *if.*HAVE''_CONFIG_H'                             \
400         halt='found use of HAVE''_CONFIG_H; remove'                     \
401           $(_sc_search_regexp)
402
403 # Nearly all .c files must include <config.h>.  However, we also permit this
404 # via inclusion of a package-specific header, if cfg.mk specified one.
405 # config_h_header must be suitable for grep -E.
406 config_h_header ?= <config\.h>
407 sc_require_config_h:
408         @require='^# *include $(config_h_header)'                       \
409         in_vc_files='\.c$$'                                             \
410         halt='the above files do not include <config.h>'                \
411           $(_sc_search_regexp)
412
413 # You must include <config.h> before including any other header file.
414 # This can possibly be via a package-specific header, if given by cfg.mk.
415 sc_require_config_h_first:
416         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then       \
417           fail=0;                                                       \
418           for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do             \
419             grep '^# *include\>' $$i | sed 1q                           \
420                 | grep -E '^# *include $(config_h_header)' > /dev/null  \
421               || { echo $$i; fail=1; };                                 \
422           done;                                                         \
423           test $$fail = 1 &&                                            \
424             { echo '$(ME): the above files include some other header'   \
425                 'before <config.h>' 1>&2; exit 1; } || :;               \
426         else :;                                                         \
427         fi
428
429 sc_prohibit_HAVE_MBRTOWC:
430         @prohibit='\bHAVE_MBRTOWC\b'                                    \
431         halt="do not use $$prohibit; it is always defined"              \
432           $(_sc_search_regexp)
433
434 # To use this "command" macro, you must first define two shell variables:
435 # h: the header name, with no enclosing <> or ""
436 # re: a regular expression that matches IFF something provided by $h is used.
437 define _sc_header_without_use
438   dummy=; : so we do not need a semicolon before each use;              \
439   h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`;                    \
440   if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then              \
441     files=$$(grep -l '^# *include '"$$h_esc"                            \
442              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
443     grep -LE "$$re" $$files | grep . &&                                 \
444       { echo "$(ME): the above files include $$h but don't use it"      \
445         1>&2; exit 1; } || :;                                           \
446   else :;                                                               \
447   fi
448 endef
449
450 # Prohibit the inclusion of assert.h without an actual use of assert.
451 sc_prohibit_assert_without_use:
452         @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
453
454 # Prohibit the inclusion of close-stream.h without an actual use.
455 sc_prohibit_close_stream_without_use:
456         @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
457
458 # Prohibit the inclusion of getopt.h without an actual use.
459 sc_prohibit_getopt_without_use:
460         @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
461
462 # Don't include quotearg.h unless you use one of its functions.
463 sc_prohibit_quotearg_without_use:
464         @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
465
466 # Don't include quote.h unless you use one of its functions.
467 sc_prohibit_quote_without_use:
468         @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
469           $(_sc_header_without_use)
470
471 # Don't include this header unless you use one of its functions.
472 sc_prohibit_long_options_without_use:
473         @h='long-options.h' re='\<parse_long_options *\(' \
474           $(_sc_header_without_use)
475
476 # Don't include this header unless you use one of its functions.
477 sc_prohibit_inttostr_without_use:
478         @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
479           $(_sc_header_without_use)
480
481 # Don't include this header unless you use one of its functions.
482 sc_prohibit_ignore_value_without_use:
483         @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
484           $(_sc_header_without_use)
485
486 # Don't include this header unless you use one of its functions.
487 sc_prohibit_error_without_use:
488         @h='error.h' \
489         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
490           $(_sc_header_without_use)
491
492 # Don't include xalloc.h unless you use one of its functions.
493 # Consider these symbols:
494 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
495 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
496 # Divide into two sets on case, and filter each through this:
497 # | sort | perl -MRegexp::Assemble -le \
498 #  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
499 # Note this was produced by the above:
500 # _xa1 = \
501 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
502 # But we can do better, in at least two ways:
503 # 1) take advantage of two "dup"-suffixed strings:
504 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
505 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
506 # "char|[cmz]"
507 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
508 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
509 _xa2 = X([CZ]|N?M)ALLOC
510 sc_prohibit_xalloc_without_use:
511         @h='xalloc.h' \
512         re='\<($(_xa1)|$(_xa2)) *\('\
513           $(_sc_header_without_use)
514
515 # Extract function names:
516 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
517 _hash_re = \
518 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
519 _hash_fn = \<($(_hash_re)) *\(
520 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
521 sc_prohibit_hash_without_use:
522         @h='hash.h' \
523         re='$(_hash_fn)|$(_hash_struct)'\
524           $(_sc_header_without_use)
525
526 sc_prohibit_cloexec_without_use:
527         @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
528           $(_sc_header_without_use)
529
530 sc_prohibit_posixver_without_use:
531         @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
532
533 sc_prohibit_same_without_use:
534         @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
535
536 sc_prohibit_hash_pjw_without_use:
537         @h='hash-pjw.h' \
538         re='\<hash_pjw\>' \
539           $(_sc_header_without_use)
540
541 sc_prohibit_safe_read_without_use:
542         @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
543           $(_sc_header_without_use)
544
545 sc_prohibit_argmatch_without_use:
546         @h='argmatch.h' \
547         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
548           $(_sc_header_without_use)
549
550 sc_prohibit_canonicalize_without_use:
551         @h='canonicalize.h' \
552         re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
553           $(_sc_header_without_use)
554
555 sc_prohibit_root_dev_ino_without_use:
556         @h='root-dev-ino.h' \
557         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
558           $(_sc_header_without_use)
559
560 sc_prohibit_openat_without_use:
561         @h='openat.h' \
562         re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
563           $(_sc_header_without_use)
564
565 # Prohibit the inclusion of c-ctype.h without an actual use.
566 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
567 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
568 sc_prohibit_c_ctype_without_use:
569         @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
570           $(_sc_header_without_use)
571
572 _empty =
573 _sp = $(_empty) $(_empty)
574 # The following list was generated by running:
575 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
576 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
577 _sig_functions = \
578   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
579   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
580   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
581   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
582 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
583 # The following were extracted from "man signal.h" manually.
584 _sig_types_and_consts =                                                 \
585   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
586   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
587   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
588   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
589   sigstack sigval stack_t ucontext_t
590 # generated via this:
591 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
592 _sig_names =                                                            \
593   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
594   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
595   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
596   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
597   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
598   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
599   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
600   SIGXCPU SIGXFSZ
601 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
602
603 # Prohibit the inclusion of signal.h without an actual use.
604 sc_prohibit_signal_without_use:
605         @h='signal.h'                                                   \
606         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
607           $(_sc_header_without_use)
608
609 # Don't include stdio--.h unless you use one of its functions.
610 sc_prohibit_stdio--_without_use:
611         @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\('              \
612           $(_sc_header_without_use)
613
614 # Don't include stdio-safer.h unless you use one of its functions.
615 sc_prohibit_stdio-safer_without_use:
616         @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\('    \
617           $(_sc_header_without_use)
618
619 # Prohibit the inclusion of strings.h without a sensible use.
620 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
621 sc_prohibit_strings_without_use:
622         @h='strings.h'                                                  \
623         re='\<(strn?casecmp|ffs(ll)?)\>'                                \
624           $(_sc_header_without_use)
625
626 # Get the list of symbol names with this:
627 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
628 _intprops_names =                                                       \
629   TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT             \
630   TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM           \
631   INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND              \
632   INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW                    \
633   INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW                 \
634   INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW                \
635   INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW  \
636   INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW         \
637   INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
638 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
639 # Prohibit the inclusion of intprops.h without an actual use.
640 sc_prohibit_intprops_without_use:
641         @h='intprops.h'                                                 \
642         re='\<($(_intprops_syms_re)) *\('                               \
643           $(_sc_header_without_use)
644
645 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
646 # Prohibit the inclusion of stddef.h without an actual use.
647 sc_prohibit_stddef_without_use:
648         @h='stddef.h'                                                   \
649         re='\<($(_stddef_syms_re))\>'                                   \
650           $(_sc_header_without_use)
651
652 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
653 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
654 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
655 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
656 # Prohibit the inclusion of dirent.h without an actual use.
657 sc_prohibit_dirent_without_use:
658         @h='dirent.h'                                                   \
659         re='\<($(_dirent_syms_re))\>'                                   \
660           $(_sc_header_without_use)
661
662 # Prohibit the inclusion of verify.h without an actual use.
663 sc_prohibit_verify_without_use:
664         @h='verify.h'                                                   \
665         re='\<(verify(true|expr)?|static_assert) *\('                   \
666           $(_sc_header_without_use)
667
668 # Don't include xfreopen.h unless you use one of its functions.
669 sc_prohibit_xfreopen_without_use:
670         @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
671
672 sc_obsolete_symbols:
673         @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
674         halt='do not use HAVE''_FCNTL_H or O'_NDELAY                    \
675           $(_sc_search_regexp)
676
677 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
678
679 # Each nonempty ChangeLog line must start with a year number, or a TAB.
680 sc_changelog:
681         @prohibit='^[^12        ]'                                      \
682         in_vc_files='^ChangeLog$$'                                      \
683         halt='found unexpected prefix in a ChangeLog'                   \
684           $(_sc_search_regexp)
685
686 # Ensure that each .c file containing a "main" function also
687 # calls set_program_name.
688 sc_program_name:
689         @require='set_program_name *\(m?argv\[0\]\);'                   \
690         in_vc_files='\.c$$'                                             \
691         containing='\<main *('                                          \
692         halt='the above files do not call set_program_name'             \
693           $(_sc_search_regexp)
694
695 # Ensure that each .c file containing a "main" function also
696 # calls bindtextdomain.
697 sc_bindtextdomain:
698         @require='bindtextdomain *\('                                   \
699         in_vc_files='\.c$$'                                             \
700         containing='\<main *('                                          \
701         halt='the above files do not call bindtextdomain'               \
702           $(_sc_search_regexp)
703
704 # Require that the final line of each test-lib.sh-using test be this one:
705 # Exit $fail
706 # Note: this test requires GNU grep's --label= option.
707 Exit_witness_file ?= tests/test-lib.sh
708 Exit_base := $(notdir $(Exit_witness_file))
709 sc_require_test_exit_idiom:
710         @if test -f $(srcdir)/$(Exit_witness_file); then                \
711           die=0;                                                        \
712           for i in $$(grep -l -F 'srcdir/$(Exit_base)'                  \
713                 $$($(VC_LIST) tests)); do                               \
714             tail -n1 $$i | grep '^Exit .' > /dev/null                   \
715               && : || { die=1; echo $$i; }                              \
716           done;                                                         \
717           test $$die = 1 &&                                             \
718             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
719               echo 1>&2 'Exit something';                               \
720               exit 1; } || :;                                           \
721         fi
722
723 sc_trailing_blank:
724         @prohibit='[     ]$$'                                           \
725         halt='found trailing blank(s)'                                  \
726           $(_sc_search_regexp)
727
728 # Match lines like the following, but where there is only one space
729 # between the options and the description:
730 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
731 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
732 sc_two_space_separator_in_usage:
733         @prohibit='^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
734         halt='help2man requires at least two spaces between an option and its description'\
735           $(_sc_search_regexp)
736
737 # A regexp matching function names like "error" that may be used
738 # to emit translatable messages.
739 _gl_translatable_diag_func_re ?= error
740
741 # Look for diagnostics that aren't marked for translation.
742 # This won't find any for which error's format string is on a separate line.
743 sc_unmarked_diagnostics:
744         @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
745         exclude='(_|ngettext ?)\('                                      \
746         halt='$(ME): found unmarked diagnostic(s)'                      \
747           $(_sc_search_regexp)
748
749 # Avoid useless parentheses like those in this example:
750 # #if defined (SYMBOL) || defined (SYM2)
751 sc_useless_cpp_parens:
752         @prohibit='^# *if .*defined *\('                                \
753         halt='found useless parentheses in cpp directive'               \
754           $(_sc_search_regexp)
755
756 # List headers for which HAVE_HEADER_H is always true, assuming you are
757 # using the appropriate gnulib module.  CAUTION: for each "unnecessary"
758 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
759 # requires the gnulib module that guarantees the usability of that header.
760 gl_assured_headers_ = \
761   cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
762
763 # Convert the list of names to upper case, and replace each space with "|".
764 az_ = abcdefghijklmnopqrstuvwxyz
765 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
766 gl_header_upper_case_or_ =                                              \
767   $$($(gl_assured_headers_)                                             \
768     | tr $(az_)/.- $(AZ_)___                                            \
769     | tr -s ' ' '|'                                                     \
770     )
771 sc_prohibit_always_true_header_tests:
772         @or=$(gl_header_upper_case_or_);                                \
773         re="HAVE_($$or)_H";                                             \
774         prohibit='\<'"$$re"'\>'                                         \
775         halt=$$(printf '%s\n'                                           \
776         'do not test the above HAVE_<header>_H symbol(s);'              \
777         '  with the corresponding gnulib module, they are always true') \
778           $(_sc_search_regexp)
779
780 # ==================================================================
781 gl_other_headers_ ?= \
782   intprops.h    \
783   openat.h      \
784   stat-macros.h
785
786 # Perl -lne code to extract "significant" cpp-defined symbols from a
787 # gnulib header file, eliminating a few common false-positives.
788 # The exempted names below are defined only conditionally in gnulib,
789 # and hence sometimes must/may be defined in application code.
790 gl_extract_significant_defines_ = \
791   /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
792     && $$2 !~ /(?:rpl_|_used_without_)/\
793     && $$1 !~ /^(?:NSIG|ENODATA)$$/\
794     && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
795     and print $$1
796
797 # Create a list of regular expressions matching the names
798 # of macros that are guaranteed to be defined by parts of gnulib.
799 define def_sym_regex
800         gen_h=$(gl_generated_headers_);                                 \
801         (cd $(gnulib_dir)/lib;                                          \
802           for f in *.in.h $(gl_other_headers_); do                      \
803             test -f $$f                                                 \
804               && perl -lne '$(gl_extract_significant_defines_)' $$f;    \
805           done;                                                         \
806         ) | sort -u                                                     \
807           | sed 's/^/^ *# *(define|undef)  */;s/$$/\\>/'
808 endef
809
810 # Don't define macros that we already get from gnulib header files.
811 sc_prohibit_always-defined_macros:
812         @if test -d $(gnulib_dir); then                                 \
813           case $$(echo all: | grep -l -f - Makefile) in Makefile);; *)  \
814             echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
815           esac;                                                         \
816           $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT))         \
817             && { echo '$(ME): define the above via some gnulib .h file' \
818                   1>&2;  exit 1; } || :;                                \
819         fi
820 # ==================================================================
821
822 # Prohibit checked in backup files.
823 sc_prohibit_backup_files:
824         @$(VC_LIST) | grep '~$$' &&                             \
825           { echo '$(ME): found version controlled backup file' 1>&2;    \
826             exit 1; } || :
827
828 # Require the latest GPL.
829 sc_GPL_version:
830         @prohibit='either ''version [^3]'                               \
831         halt='GPL vN, N!=3'                                             \
832           $(_sc_search_regexp)
833
834 # Require the latest GFDL.  Two regexp, since some .texi files end up
835 # line wrapping between 'Free Documentation License,' and 'Version'.
836 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
837 sc_GFDL_version:
838         @prohibit='$(_GFDL_regexp)'                                     \
839         halt='GFDL vN, N!=3'                                            \
840           $(_sc_search_regexp)
841
842 # Don't use Texinfo's @acronym{}.
843 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
844 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
845 sc_texinfo_acronym:
846         @prohibit='@acronym\{'                                          \
847         in_vc_files='$(texinfo_suffix_re_)'                             \
848         halt='found use of Texinfo @acronym{}'                          \
849           $(_sc_search_regexp)
850
851 cvs_keywords = \
852   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
853
854 sc_prohibit_cvs_keyword:
855         @prohibit='\$$($(cvs_keywords))\$$'                             \
856         halt='do not use CVS keyword expansion'                         \
857           $(_sc_search_regexp)
858
859 # This Perl code is slightly obfuscated.  Not only is each "$" doubled
860 # because it's in a Makefile, but the $$c's are comments;  we cannot
861 # use "#" due to the way the script ends up concatenated onto one line.
862 # It would be much more concise, and would produce better output (including
863 # counts) if written as:
864 #   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
865 # but that would be far less efficient, reading the entire contents
866 # of each file, rather than just the last two bytes of each.
867 # In addition, while the code below detects both blank lines and a missing
868 # newline at EOF, the above detects only the former.
869 #
870 # This is a perl script that is expected to be the single-quoted argument
871 # to a command-line "-le".  The remaining arguments are file names.
872 # Print the name of each file that does not end in exactly one newline byte.
873 # I.e., warn if there are blank lines (2 or more newlines), or if the
874 # last byte is not a newline.  However, currently we don't complain
875 # about any file that contains exactly one byte.
876 # Exit nonzero if at least one such file is found, otherwise, exit 0.
877 # Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
878 #
879 # Use this if you want to remove trailing empty lines from selected files:
880 #   perl -pi -0777 -e 's/\n\n+$/\n/' files...
881 #
882 require_exactly_one_NL_at_EOF_ =                                        \
883   foreach my $$f (@ARGV)                                                \
884     {                                                                   \
885       open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;     \
886       my $$p = sysseek (F, -2, 2);                                      \
887       my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
888       my $$last_two_bytes;                                              \
889       defined $$p and $$p = sysread F, $$last_two_bytes, 2;             \
890       close F;                                                          \
891       $$c = "ignore read failure";                                      \
892       $$p && ($$last_two_bytes eq "\n\n"                                \
893               || substr ($$last_two_bytes,1) ne "\n")                   \
894           and (print $$f), $$fail=1;                                    \
895     }                                                                   \
896   END { exit defined $$fail }
897 sc_prohibit_empty_lines_at_EOF:
898         @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
899           || { echo '$(ME): empty line(s) or no newline at EOF'         \
900                 1>&2; exit 1; } || :
901
902 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
903 # This is a bit of a kludge, since it prevents use of the string
904 # even in comments, but for now it does the job with no false positives.
905 sc_prohibit_stat_st_blocks:
906         @prohibit='[.>]st_blocks'                                       \
907         halt='do not use st_blocks; use ST_NBLOCKS'                     \
908           $(_sc_search_regexp)
909
910 # Make sure we don't define any S_IS* macros in src/*.c files.
911 # They're already defined via gnulib's sys/stat.h replacement.
912 sc_prohibit_S_IS_definition:
913         @prohibit='^ *# *define  *S_IS'                                 \
914         halt='do not define S_IS* macros; include <sys/stat.h>'         \
915           $(_sc_search_regexp)
916
917 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
918 # that is shared by two definitions below.
919 perl_filename_lineno_text_ =                                            \
920     -e '  {'                                                            \
921     -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'                              \
922     -e '    ($$v = $$&) =~ s/\n/\\n/g;'                                 \
923     -e '    print "$$ARGV:$$n:$$v\n";'                                  \
924     -e '  }'
925
926 prohibit_doubled_word_RE_ ?= \
927   /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
928 prohibit_doubled_word_ =                                                \
929     -e 'while ($(prohibit_doubled_word_RE_))'                           \
930     $(perl_filename_lineno_text_)
931
932 # Define this to a regular expression that matches
933 # any filename:dd:match lines you want to ignore.
934 # The default is to ignore no matches.
935 ignore_doubled_word_match_RE_ ?= ^$$
936
937 sc_prohibit_doubled_word:
938         @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT))  \
939           | grep -vE '$(ignore_doubled_word_match_RE_)'                 \
940           | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
941
942 # A regular expression matching undesirable combinations of words like
943 # "can not"; this matches them even when the two words appear on different
944 # lines, but not when there is an intervening delimiter like "#" or "*".
945 # Similarly undesirable, "See @xref{...}", since an @xref should start
946 # a sentence.  Explicitly prohibit any prefix of "see" or "also".
947 # Also prohibit a prefix matching "\w+ +".
948 # @pxref gets the same see/also treatment and should be parenthesized;
949 # presume it must *not* start a sentence.
950 bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
951 bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
952 prohibit_undesirable_word_seq_RE_ ?=                                    \
953   /(?:\bcan\s+not\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
954 prohibit_undesirable_word_seq_ =                                        \
955     -e 'while ($(prohibit_undesirable_word_seq_RE_))'                   \
956     $(perl_filename_lineno_text_)
957 # Define this to a regular expression that matches
958 # any filename:dd:match lines you want to ignore.
959 # The default is to ignore no matches.
960 ignore_undesirable_word_sequence_RE_ ?= ^$$
961
962 sc_prohibit_undesirable_word_seq:
963         @perl -n -0777 $(prohibit_undesirable_word_seq_)                \
964              $$($(VC_LIST_EXCEPT))                                      \
965           | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
966           && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
967
968 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
969 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
970 # Using test's -a and -o operators is not portable.
971 # We prefer test over [, since the latter is spelled [[ in configure.ac.
972 sc_prohibit_test_minus_ao:
973         @prohibit='(\<test| \[+) .+ -[ao] '                             \
974         halt='$(_ptm1); $(_ptm2)'                                       \
975           $(_sc_search_regexp)
976
977 # Avoid a test bashism.
978 sc_prohibit_test_double_equal:
979         @prohibit='(\<test| \[+) .+ == '                                \
980         containing='#! */bin/[a-z]*sh'                                  \
981         halt='use "test x = x", not "test x =''= x"'                    \
982           $(_sc_search_regexp)
983
984 # Each program that uses proper_name_utf8 must link with one of the
985 # ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
986 # The perl -0777 invocation below extracts the possibly-multi-line
987 # definition of LDADD from the appropriate Makefile.am and exits 0
988 # when it contains "ICONV".
989 sc_proper_name_utf8_requires_ICONV:
990         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
991         if test "x$$progs" != x; then                                   \
992           fail=0;                                                       \
993           for p in $$progs; do                                          \
994             dir=$$(dirname "$$p");                                      \
995             perl -0777                                                  \
996               -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'  \
997               $$dir/Makefile.am && continue;                            \
998             base=$$(basename "$$p" .c);                                 \
999             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
1000               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1001           done;                                                         \
1002           test $$fail = 1 &&                                            \
1003             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1004               exit 1; } || :;                                           \
1005         fi
1006
1007 # Warn about "c0nst struct Foo const foo[]",
1008 # but not about "char const *const foo" or "#define const const".
1009 sc_redundant_const:
1010         @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'          \
1011         halt='redundant "const" in declarations'                        \
1012           $(_sc_search_regexp)
1013
1014 sc_const_long_option:
1015         @prohibit='^ *static.*struct option '                           \
1016         exclude='const struct option|struct option const'               \
1017         halt='$(ME): add "const" to the above declarations'             \
1018           $(_sc_search_regexp)
1019
1020 NEWS_hash =                                                             \
1021   $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'              \
1022        $(srcdir)/NEWS                                                   \
1023      | perl -0777 -pe                                                   \
1024         's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'       \
1025      | md5sum -                                                         \
1026      | sed 's/ .*//')
1027
1028 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1029 sc_immutable_NEWS:
1030         @if test -f $(srcdir)/NEWS; then                                \
1031           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
1032             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1033         fi
1034
1035 # Update the hash stored above.  Do this after each release and
1036 # for any corrections to old entries.
1037 update-NEWS-hash: NEWS
1038         perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1039           $(srcdir)/cfg.mk
1040
1041 # Ensure that we use only the standard $(VAR) notation,
1042 # not @...@ in Makefile.am, now that we can rely on automake
1043 # to emit a definition for each substituted variable.
1044 # However, there is still one case in which @VAR@ use is not just
1045 # legitimate, but actually required: when augmenting an automake-defined
1046 # variable with a prefix.  For example, gettext uses this:
1047 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1048 # otherwise, makeinfo would put German or French (current locale)
1049 # navigation hints in the otherwise-English documentation.
1050 #
1051 # Allow the package to add exceptions via a hook in cfg.mk;
1052 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1053 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1054 _makefile_at_at_check_exceptions ?=
1055 sc_makefile_at_at_check:
1056         @perl -ne '/\@\w+\@/'                                           \
1057           -e ' && !/(\w+)\s+=.*\@\1\@$$/'                               \
1058           -e ''$(_makefile_at_at_check_exceptions)                      \
1059           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
1060             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1061           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1062
1063 news-check: NEWS
1064         if sed -n $(news-check-lines-spec)p $<                          \
1065             | grep -E $(news-check-regexp) >/dev/null; then             \
1066           :;                                                            \
1067         else                                                            \
1068           echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2;      \
1069           exit 1;                                                       \
1070         fi
1071
1072 sc_makefile_TAB_only_indentation:
1073         @prohibit='^    [ ]{8}'                                         \
1074         in_vc_files='akefile|\.mk$$'                                    \
1075         halt='found TAB-8-space indentation'                            \
1076           $(_sc_search_regexp)
1077
1078 sc_m4_quote_check:
1079         @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
1080         in_vc_files='(^configure\.ac|\.m4)$$'                           \
1081         halt='quote the first arg to AC_DEF*'                           \
1082           $(_sc_search_regexp)
1083
1084 fix_po_file_diag = \
1085 'you have changed the set of files with translatable diagnostics;\n\
1086 apply the above patch\n'
1087
1088 # Verify that all source files using _() are listed in po/POTFILES.in.
1089 po_file ?= $(srcdir)/po/POTFILES.in
1090 generated_files ?= $(srcdir)/lib/*.[ch]
1091 sc_po_check:
1092         @if test -f $(po_file); then                                    \
1093           grep -E -v '^(#|$$)' $(po_file)                               \
1094             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
1095           files=;                                                       \
1096           for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do      \
1097             test -r $$file || continue;                                 \
1098             case $$file in                                              \
1099               *.m4|*.mk) continue ;;                                    \
1100               *.?|*.??) ;;                                              \
1101               *) continue;;                                             \
1102             esac;                                                       \
1103             case $$file in                                              \
1104             *.[ch])                                                     \
1105               base=`expr " $$file" : ' \(.*\)\..'`;                     \
1106               { test -f $$base.l || test -f $$base.y; } && continue;;   \
1107             esac;                                                       \
1108             files="$$files $$file";                                     \
1109           done;                                                         \
1110           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
1111             | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2;      \
1112           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
1113             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
1114           rm -f $@-1 $@-2;                                              \
1115         fi
1116
1117 # Sometimes it is useful to change the PATH environment variable
1118 # in Makefiles.  When doing so, it's better not to use the Unix-centric
1119 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1120 msg = '$(ME): Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1121 sc_makefile_path_separator_check:
1122         @prohibit='PATH[=].*:'                                          \
1123         in_vc_files='akefile|\.mk$$'                                    \
1124         halt=$(msg)                                                     \
1125           $(_sc_search_regexp)
1126
1127 # Check that 'make alpha' will not fail at the end of the process,
1128 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1129 # and is read-only.
1130 writable-files:
1131         if test -d $(release_archive_dir); then                         \
1132           for file in $(DIST_ARCHIVES); do                              \
1133             for p in ./ $(release_archive_dir)/; do                     \
1134               test -e $$p$$file || continue;                            \
1135               test -w $$p$$file                                         \
1136                 || { echo ERROR: $$p$$file is not writable; fail=1; };  \
1137             done;                                                       \
1138           done;                                                         \
1139           test "$$fail" && exit 1 || : ;                                \
1140         else :;                                                         \
1141         fi
1142
1143 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1144 sample-test = tests/sample-test
1145 texi = doc/$(PACKAGE).texi
1146 # Make sure that the copyright date in $(v_etc_file) is up to date.
1147 # Do the same for the $(sample-test) and the main doc/.texi file.
1148 sc_copyright_check:
1149         @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };'            \
1150         in_files=$(v_etc_file)                                          \
1151         halt='out of date copyright in $(v_etc_file); update it'        \
1152           $(_sc_search_regexp)
1153         @require='# Copyright \(C\) '$$(date +%Y)' Free'                \
1154         in_vc_files=$(sample-test)                                      \
1155         halt='out of date copyright in $(sample-test); update it'       \
1156           $(_sc_search_regexp)
1157         @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free'       \
1158         in_vc_files=$(texi)                                             \
1159         halt='out of date copyright in $(texi); update it'              \
1160           $(_sc_search_regexp)
1161
1162 # If tests/help-version exists and seems to be new enough, assume that its
1163 # use of init.sh and path_prepend_ is correct, and ensure that every other
1164 # use of init.sh is identical.
1165 # This is useful because help-version cross-checks prog --version
1166 # with $(VERSION), which verifies that its path_prepend_ invocation
1167 # sets PATH correctly.  This is an inexpensive way to ensure that
1168 # the other init.sh-using tests also get it right.
1169 _hv_file ?= $(srcdir)/tests/help-version
1170 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1171 # Fix syntax-highlighters "
1172 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1173 sc_cross_check_PATH_usage_in_tests:
1174         @if test -f $(_hv_file); then                                   \
1175           grep -l 'VERSION mismatch' $(_hv_file) >/dev/null             \
1176             || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2;    \
1177                  exit 0; };                                             \
1178           grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null         \
1179             || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1180                  exit 1; };                                             \
1181           good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file));           \
1182           grep -LFx "$$good"                                            \
1183                 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT)))  \
1184               | grep . &&                                               \
1185             { echo "$(ME): the above files use path_prepend_ inconsistently" \
1186                 1>&2; exit 1; } || :;                                   \
1187         fi
1188
1189 # BRE regex of file contents to identify a test script.
1190 _test_script_regex ?= \<init\.sh\>
1191
1192 # In tests, use "compare expected actual", not the reverse.
1193 sc_prohibit_reversed_compare_failure:
1194         @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)'                \
1195         containing='$(_test_script_regex)'                              \
1196         halt='reversed compare arguments'                               \
1197           $(_sc_search_regexp)
1198
1199 # #if HAVE_... will evaluate to false for any non numeric string.
1200 # That would be flagged by using -Wundef, however gnulib currently
1201 # tests many undefined macros, and so we can't enable that option.
1202 # So at least preclude common boolean strings as macro values.
1203 sc_Wundef_boolean:
1204         @prohibit='^#define.*(yes|no|true|false)$$'                     \
1205         in_files='$(CONFIG_INCLUDE)'                                    \
1206         halt='Use 0 or 1 for macro values'                              \
1207           $(_sc_search_regexp)
1208
1209 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1210 # not be constant, or might overflow a stack.  In general, use PATH_MAX as
1211 # a limit, not an array or alloca size.
1212 sc_prohibit_path_max_allocation:
1213         @prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX'                 \
1214         halt='Avoid stack allocations of size PATH_MAX'                 \
1215           $(_sc_search_regexp)
1216
1217 sc_vulnerable_makefile_CVE-2009-4029:
1218         @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1219         in_files=(^\|/)Makefile\\.in$$                                  \
1220         halt=$$(printf '%s\n'                                           \
1221           'the above files are vulnerable; beware of running'           \
1222           '  "make dist*" rules, and upgrade to fixed automake'         \
1223           '  see http://bugzilla.redhat.com/542609 for details')        \
1224           $(_sc_search_regexp)
1225
1226 sc_vulnerable_makefile_CVE-2012-3386:
1227         @prohibit='chmod a\+w \$$\(distdir\)'                           \
1228         in_files=(^\|/)Makefile\\.in$$                                  \
1229         halt=$$(printf '%s\n'                                           \
1230           'the above files are vulnerable; beware of running'           \
1231           '  "make distcheck", and upgrade to fixed automake'           \
1232           '  see http://bugzilla.redhat.com/CVE-2012-3386 for details') \
1233           $(_sc_search_regexp)
1234
1235 vc-diff-check:
1236         (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1237         if test -s vc-diffs; then                               \
1238           cat vc-diffs;                                         \
1239           echo "Some files are locally modified:" 1>&2;         \
1240           exit 1;                                               \
1241         else                                                    \
1242           rm vc-diffs;                                          \
1243         fi
1244
1245 rel-files = $(DIST_ARCHIVES)
1246
1247 gnulib_dir ?= $(srcdir)/gnulib
1248 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1249 bootstrap-tools ?= autoconf,automake,gnulib
1250
1251 # If it's not already specified, derive the GPG key ID from
1252 # the signed tag we've just applied to mark this release.
1253 gpg_key_ID ?= \
1254   $$(git cat-file tag v$(VERSION) \
1255      | gpgv --status-fd 1 --keyring /dev/null - - 2>/dev/null \
1256      | awk '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
1257
1258 translation_project_ ?= coordinator@translationproject.org
1259
1260 # Make info-gnu the default only for a stable release.
1261 ifeq ($(RELEASE_TYPE),stable)
1262   announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1263   announcement_mail_headers_ ?=                                         \
1264     To: info-gnu@gnu.org                                                \
1265     Cc: $(announcement_Cc_)                                             \
1266     Mail-Followup-To: $(PACKAGE_BUGREPORT)
1267 else
1268   announcement_Cc_ ?= $(translation_project_)
1269   announcement_mail_headers_ ?=                                         \
1270     To: $(PACKAGE_BUGREPORT)                                            \
1271     Cc: $(announcement_Cc_)
1272 endif
1273
1274 announcement: NEWS ChangeLog $(rel-files)
1275         @$(srcdir)/$(_build-aux)/announce-gen                           \
1276             --mail-headers='$(announcement_mail_headers_)'              \
1277             --release-type=$(RELEASE_TYPE)                              \
1278             --package=$(PACKAGE)                                        \
1279             --prev=$(PREV_VERSION)                                      \
1280             --curr=$(VERSION)                                           \
1281             --gpg-key-id=$(gpg_key_ID)                                  \
1282             --srcdir=$(srcdir)                                          \
1283             --news=$(srcdir)/NEWS                                       \
1284             --bootstrap-tools=$(bootstrap-tools)                        \
1285             $$(case ,$(bootstrap-tools), in (*,gnulib,*)                \
1286                echo --gnulib-version=$(gnulib-version);; esac)          \
1287             --no-print-checksums                                        \
1288             $(addprefix --url-dir=, $(url_dir_list))
1289
1290 ## ---------------- ##
1291 ## Updating files.  ##
1292 ## ---------------- ##
1293
1294 ftp-gnu = ftp://ftp.gnu.org/gnu
1295 www-gnu = http://www.gnu.org
1296
1297 upload_dest_dir_ ?= $(PACKAGE)
1298 emit_upload_commands:
1299         @echo =====================================
1300         @echo =====================================
1301         @echo "$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
1302         @echo "    --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1303         @echo "  $(rel-files)"
1304         @echo '# send the ~/announce-$(my_distdir) e-mail'
1305         @echo =====================================
1306         @echo =====================================
1307
1308 define emit-commit-log
1309   printf '%s\n' 'maint: post-release administrivia' ''                  \
1310     '* NEWS: Add header line for next release.'                         \
1311     '* .prev-version: Record previous version.'                         \
1312     '* cfg.mk (old_NEWS_hash): Auto-update.'
1313 endef
1314
1315 .PHONY: no-submodule-changes
1316 no-submodule-changes:
1317         if test -d $(srcdir)/.git; then                                 \
1318           diff=$$(cd $(srcdir) && git submodule -q foreach              \
1319                   git diff-index --name-only HEAD)                      \
1320             || exit 1;                                                  \
1321           case $$diff in '') ;;                                         \
1322             *) echo '$(ME): submodule files are locally modified:';     \
1323                 echo "$$diff"; exit 1;; esac;                           \
1324         else                                                            \
1325           : ;                                                           \
1326         fi
1327
1328 submodule-checks ?= no-submodule-changes public-submodule-commit
1329
1330 # Ensure that each sub-module commit we're using is public.
1331 # Without this, it is too easy to tag and release code that
1332 # cannot be built from a fresh clone.
1333 .PHONY: public-submodule-commit
1334 public-submodule-commit:
1335         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1336           cd $(srcdir) &&                                               \
1337           git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1338               = '$$(git merge-base origin $$sha1)'                      \
1339             || { echo '$(ME): found non-public submodule commit' >&2;   \
1340                  exit 1; };                                             \
1341         else                                                            \
1342           : ;                                                           \
1343         fi
1344 # This rule has a high enough utility/cost ratio that it should be a
1345 # dependent of "check" by default.  However, some of us do occasionally
1346 # commit a temporary change that deliberately points to a non-public
1347 # submodule commit, and want to be able to use rules like "make check".
1348 # In that case, run e.g., "make check gl_public_submodule_commit="
1349 # to disable this test.
1350 gl_public_submodule_commit ?= public-submodule-commit
1351 check: $(gl_public_submodule_commit)
1352
1353 .PHONY: alpha beta stable
1354 ALL_RECURSIVE_TARGETS += alpha beta stable
1355 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1356         test $@ = stable                                                \
1357           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$'         \
1358                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1359           || :
1360         $(MAKE) vc-diff-check
1361         $(MAKE) news-check
1362         $(MAKE) distcheck
1363         $(MAKE) dist
1364         $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1365         $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1366
1367 # Override this in cfg.mk if you follow different procedures.
1368 release-prep-hook ?= release-prep
1369
1370 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1371 .PHONY: release-prep
1372 release-prep:
1373         case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1374           *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1375         $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
1376         if test -d $(release_archive_dir); then                 \
1377           ln $(rel-files) $(release_archive_dir);               \
1378           chmod a-w $(rel-files);                               \
1379         fi
1380         echo $(VERSION) > $(prev_version_file)
1381         $(MAKE) update-NEWS-hash
1382         perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' $(srcdir)/NEWS
1383         $(emit-commit-log) > .ci-msg
1384         $(VC) commit -F .ci-msg -a
1385         rm .ci-msg
1386
1387 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1388 # if the default $(PACKAGE)-derived name doesn't apply.
1389 gendocs_options_ ?=
1390
1391 .PHONY: web-manual
1392 web-manual:
1393         @test -z "$(manual_title)" \
1394           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1395         @cd '$(srcdir)/doc'; \
1396           $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1397              -o '$(abs_builddir)/doc/manual' \
1398              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1399             "$(PACKAGE_NAME) - $(manual_title)"
1400         @echo " *** Upload the doc/manual directory to web-cvs."
1401
1402 # Code Coverage
1403
1404 init-coverage:
1405         $(MAKE) $(AM_MAKEFLAGS) clean
1406         lcov --directory . --zerocounters
1407
1408 COVERAGE_CCOPTS ?= "-g --coverage"
1409 COVERAGE_OUT ?= doc/coverage
1410
1411 build-coverage:
1412         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1413         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1414         mkdir -p $(COVERAGE_OUT)
1415         lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1416                 --capture
1417
1418 gen-coverage:
1419         genhtml --output-directory $(COVERAGE_OUT) \
1420                 $(COVERAGE_OUT)/$(PACKAGE).info \
1421                 --highlight --frames --legend \
1422                 --title "$(PACKAGE_NAME)"
1423
1424 coverage: init-coverage build-coverage gen-coverage
1425
1426 # Update gettext files.
1427 PACKAGE ?= $(shell basename $(PWD))
1428 PO_DOMAIN ?= $(PACKAGE)
1429 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1430 PODIR ?= po
1431 refresh-po:
1432         rm -f $(PODIR)/*.po && \
1433         echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1434         wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1435         echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1436         echo 'en@quot' >> $(PODIR)/LINGUAS && \
1437         ls $(PODIR)/*.po | sed 's/\.po//;s,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1438
1439  # Running indent once is not idempotent, but running it twice is.
1440 INDENT_SOURCES ?= $(C_SOURCES)
1441 .PHONY: indent
1442 indent:
1443         indent $(INDENT_SOURCES)
1444         indent $(INDENT_SOURCES)
1445
1446 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1447 # put the assignments in this variable.
1448 update-copyright-env ?=
1449
1450 # Run this rule once per year (usually early in January)
1451 # to update all FSF copyright year lists in your project.
1452 # If you have an additional project-specific rule,
1453 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1454 # By default, exclude all variants of COPYING; you can also
1455 # add exemptions (such as ChangeLog..* for rotated change logs)
1456 # in the file .x-update-copyright.
1457 .PHONY: update-copyright
1458 update-copyright:
1459         grep -l -w Copyright                                             \
1460           $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1461           | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1462
1463 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1464 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1465
1466 # NOTE: to override any _gl_TS_* default value, you must
1467 # define the variable(s) using "export" in cfg.mk.
1468 _gl_TS_dir ?= src
1469
1470 ALL_RECURSIVE_TARGETS += sc_tight_scope
1471 sc_tight_scope: tight-scope.mk
1472         @fail=0;                                                        \
1473         if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk        \
1474                 > /dev/null                                             \
1475            && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1476                 > /dev/null 2>&1; then                                  \
1477             echo '$(ME): skipping $@';                                  \
1478         else                                                            \
1479             $(MAKE) -s -C $(_gl_TS_dir)                                 \
1480                 -f Makefile                                             \
1481                 -f $(abs_top_srcdir)/cfg.mk                             \
1482                 -f $(abs_top_builddir)/$<                               \
1483               _gl_tight_scope                                           \
1484                 || fail=1;                                              \
1485         fi;                                                             \
1486         rm -f $<;                                                       \
1487         exit $$fail
1488
1489 tight-scope.mk: $(ME)
1490         @rm -f $@ $@-t
1491         @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1492         @chmod a=r $@-t && mv $@-t $@
1493
1494 ifeq (a,b)
1495 # TS-start
1496
1497 # Most functions should have static scope.
1498 # Any that don't must be marked with 'extern', but 'main'
1499 # and 'usage' are exceptions: they're always extern, but
1500 # do not need to be marked.  Symbols matching '__.*' are
1501 # reserved by the compiler, so are automatically excluded below.
1502 _gl_TS_unmarked_extern_functions ?= main usage
1503 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
1504
1505 # If your project uses a macro like "XTERN", then put
1506 # the following in cfg.mk to override this default:
1507 # export _gl_TS_extern = extern|XTERN
1508 _gl_TS_extern ?= extern
1509
1510 # The second nm|grep checks for file-scope variables with 'extern' scope.
1511 # Without gnulib's progname module, you might put program_name here.
1512 # Symbols matching '__.*' are reserved by the compiler,
1513 # so are automatically excluded below.
1514 _gl_TS_unmarked_extern_vars ?=
1515
1516 # NOTE: the _match variables are perl expressions -- not mere regular
1517 # expressions -- so that you can extend them to match other patterns
1518 # and easily extract matched variable names.
1519 # For example, if your project declares some global variables via
1520 # a macro like this: GLOBAL(type, var_name, initializer), then you
1521 # can override this definition to automatically extract those names:
1522 # export _gl_TS_var_match = \
1523 #   /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1524 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1525
1526 # The names of object files in (or relative to) $(_gl_TS_dir).
1527 _gl_TS_obj_files ?= *.$(OBJEXT)
1528
1529 # Files in which to search for the one-line style extern declarations.
1530 # $(_gl_TS_dir)-relative.
1531 _gl_TS_headers ?= $(noinst_HEADERS)
1532
1533 .PHONY: _gl_tight_scope
1534 _gl_tight_scope: $(bin_PROGRAMS)
1535         t=exceptions-$$$$;                                              \
1536         trap 's=$$?; rm -f $$t; exit $$s' 0;                            \
1537         for sig in 1 2 3 13 15; do                                      \
1538           eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1539         done;                                                           \
1540         src=`for f in $(SOURCES); do                                    \
1541                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1542         hdr=`for f in $(_gl_TS_headers); do                             \
1543                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1544         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions);  \
1545           grep -h -A1 '^extern .*[^;]$$' $$src                          \
1546             | grep -vE '^(extern |--)' | sed 's/ .*//';                 \
1547           perl -lne                                                     \
1548              '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr;      \
1549         ) | sort -u > $$t;                                              \
1550         nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1551           && { echo the above functions should have static scope >&2;   \
1552                exit 1; } || : ;                                         \
1553         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars);       \
1554           perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1555         ) | sort -u > $$t;                                              \
1556         nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p'          \
1557             | sort -u | grep -Ev -f $$t                                 \
1558           && { echo the above variables should have static scope >&2;   \
1559                exit 1; } || :
1560 # TS-end
1561 endif